# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import AdminAgentWorkPlanBiddingPreference
    from . import WorkPlanReference

class AdminAgentWorkPlanPreferenceResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        AdminAgentWorkPlanPreferenceResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'work_plans': 'list[WorkPlanReference]',
            'agent_work_plan_bid_preferences': 'list[AdminAgentWorkPlanBiddingPreference]',
            'self_uri': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'work_plans': 'workPlans',
            'agent_work_plan_bid_preferences': 'agentWorkPlanBidPreferences',
            'self_uri': 'selfUri'
        }

        self._id = None
        self._work_plans = None
        self._agent_work_plan_bid_preferences = None
        self._self_uri = None

    @property
    def id(self) -> str:
        """
        Gets the id of this AdminAgentWorkPlanPreferenceResponse.
        The globally unique identifier for the object.

        :return: The id of this AdminAgentWorkPlanPreferenceResponse.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this AdminAgentWorkPlanPreferenceResponse.
        The globally unique identifier for the object.

        :param id: The id of this AdminAgentWorkPlanPreferenceResponse.
        :type: str
        """
        

        self._id = id

    @property
    def work_plans(self) -> List['WorkPlanReference']:
        """
        Gets the work_plans of this AdminAgentWorkPlanPreferenceResponse.
        The list of work plans that belong to this bid group

        :return: The work_plans of this AdminAgentWorkPlanPreferenceResponse.
        :rtype: list[WorkPlanReference]
        """
        return self._work_plans

    @work_plans.setter
    def work_plans(self, work_plans: List['WorkPlanReference']) -> None:
        """
        Sets the work_plans of this AdminAgentWorkPlanPreferenceResponse.
        The list of work plans that belong to this bid group

        :param work_plans: The work_plans of this AdminAgentWorkPlanPreferenceResponse.
        :type: list[WorkPlanReference]
        """
        

        self._work_plans = work_plans

    @property
    def agent_work_plan_bid_preferences(self) -> List['AdminAgentWorkPlanBiddingPreference']:
        """
        Gets the agent_work_plan_bid_preferences of this AdminAgentWorkPlanPreferenceResponse.
        The list of agents work plan bidding preferences

        :return: The agent_work_plan_bid_preferences of this AdminAgentWorkPlanPreferenceResponse.
        :rtype: list[AdminAgentWorkPlanBiddingPreference]
        """
        return self._agent_work_plan_bid_preferences

    @agent_work_plan_bid_preferences.setter
    def agent_work_plan_bid_preferences(self, agent_work_plan_bid_preferences: List['AdminAgentWorkPlanBiddingPreference']) -> None:
        """
        Sets the agent_work_plan_bid_preferences of this AdminAgentWorkPlanPreferenceResponse.
        The list of agents work plan bidding preferences

        :param agent_work_plan_bid_preferences: The agent_work_plan_bid_preferences of this AdminAgentWorkPlanPreferenceResponse.
        :type: list[AdminAgentWorkPlanBiddingPreference]
        """
        

        self._agent_work_plan_bid_preferences = agent_work_plan_bid_preferences

    @property
    def self_uri(self) -> str:
        """
        Gets the self_uri of this AdminAgentWorkPlanPreferenceResponse.
        The URI for this object

        :return: The self_uri of this AdminAgentWorkPlanPreferenceResponse.
        :rtype: str
        """
        return self._self_uri

    @self_uri.setter
    def self_uri(self, self_uri: str) -> None:
        """
        Sets the self_uri of this AdminAgentWorkPlanPreferenceResponse.
        The URI for this object

        :param self_uri: The self_uri of this AdminAgentWorkPlanPreferenceResponse.
        :type: str
        """
        

        self._self_uri = self_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

