# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import CopilotAction
    from . import CopilotCondition

class CopilotRule(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        CopilotRule - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'conditions': 'list[CopilotCondition]',
            'actions': 'list[CopilotAction]'
        }

        self.attribute_map = {
            'conditions': 'conditions',
            'actions': 'actions'
        }

        self._conditions = None
        self._actions = None

    @property
    def conditions(self) -> List['CopilotCondition']:
        """
        Gets the conditions of this CopilotRule.
        List of conditions to execute actions, must have at least 1 element and maximum 100 elements. Operator in case of multiple conditions: 'OR'.

        :return: The conditions of this CopilotRule.
        :rtype: list[CopilotCondition]
        """
        return self._conditions

    @conditions.setter
    def conditions(self, conditions: List['CopilotCondition']) -> None:
        """
        Sets the conditions of this CopilotRule.
        List of conditions to execute actions, must have at least 1 element and maximum 100 elements. Operator in case of multiple conditions: 'OR'.

        :param conditions: The conditions of this CopilotRule.
        :type: list[CopilotCondition]
        """
        

        self._conditions = conditions

    @property
    def actions(self) -> List['CopilotAction']:
        """
        Gets the actions of this CopilotRule.
        List of actions to execute, must have at least 1 element and maximum 100 elements.

        :return: The actions of this CopilotRule.
        :rtype: list[CopilotAction]
        """
        return self._actions

    @actions.setter
    def actions(self, actions: List['CopilotAction']) -> None:
        """
        Sets the actions of this CopilotRule.
        List of actions to execute, must have at least 1 element and maximum 100 elements.

        :param actions: The actions of this CopilotRule.
        :type: list[CopilotAction]
        """
        

        self._actions = actions

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

