# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import ConversationProfile

class GoogleDialogflowConfig(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        GoogleDialogflowConfig - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'integration_id': 'str',
            'conversation_profiles': 'list[ConversationProfile]'
        }

        self.attribute_map = {
            'integration_id': 'integrationId',
            'conversation_profiles': 'conversationProfiles'
        }

        self._integration_id = None
        self._conversation_profiles = None

    @property
    def integration_id(self) -> str:
        """
        Gets the integration_id of this GoogleDialogflowConfig.
        The integration identifier with which the assistant will fetch transcriptions and knowledge suggestions.

        :return: The integration_id of this GoogleDialogflowConfig.
        :rtype: str
        """
        return self._integration_id

    @integration_id.setter
    def integration_id(self, integration_id: str) -> None:
        """
        Sets the integration_id of this GoogleDialogflowConfig.
        The integration identifier with which the assistant will fetch transcriptions and knowledge suggestions.

        :param integration_id: The integration_id of this GoogleDialogflowConfig.
        :type: str
        """
        

        self._integration_id = integration_id

    @property
    def conversation_profiles(self) -> List['ConversationProfile']:
        """
        Gets the conversation_profiles of this GoogleDialogflowConfig.
        The conversation profiles for which the assistant will fetch transcription and knowledge suggestions.

        :return: The conversation_profiles of this GoogleDialogflowConfig.
        :rtype: list[ConversationProfile]
        """
        return self._conversation_profiles

    @conversation_profiles.setter
    def conversation_profiles(self, conversation_profiles: List['ConversationProfile']) -> None:
        """
        Sets the conversation_profiles of this GoogleDialogflowConfig.
        The conversation profiles for which the assistant will fetch transcription and knowledge suggestions.

        :param conversation_profiles: The conversation_profiles of this GoogleDialogflowConfig.
        :type: list[ConversationProfile]
        """
        

        self._conversation_profiles = conversation_profiles

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

