# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class LexV2Bot(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        LexV2Bot - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'name': 'str',
            'bot_id': 'str',
            'region': 'str',
            'description': 'str',
            'self_uri': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'bot_id': 'botId',
            'region': 'region',
            'description': 'description',
            'self_uri': 'selfUri'
        }

        self._id = None
        self._name = None
        self._bot_id = None
        self._region = None
        self._description = None
        self._self_uri = None

    @property
    def id(self) -> str:
        """
        Gets the id of this LexV2Bot.
        The globally unique identifier for the object.

        :return: The id of this LexV2Bot.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this LexV2Bot.
        The globally unique identifier for the object.

        :param id: The id of this LexV2Bot.
        :type: str
        """
        

        self._id = id

    @property
    def name(self) -> str:
        """
        Gets the name of this LexV2Bot.


        :return: The name of this LexV2Bot.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str) -> None:
        """
        Sets the name of this LexV2Bot.


        :param name: The name of this LexV2Bot.
        :type: str
        """
        

        self._name = name

    @property
    def bot_id(self) -> str:
        """
        Gets the bot_id of this LexV2Bot.
        Lex V2 bot Id

        :return: The bot_id of this LexV2Bot.
        :rtype: str
        """
        return self._bot_id

    @bot_id.setter
    def bot_id(self, bot_id: str) -> None:
        """
        Sets the bot_id of this LexV2Bot.
        Lex V2 bot Id

        :param bot_id: The bot_id of this LexV2Bot.
        :type: str
        """
        

        self._bot_id = bot_id

    @property
    def region(self) -> str:
        """
        Gets the region of this LexV2Bot.
        A region of the Lex V2 bot

        :return: The region of this LexV2Bot.
        :rtype: str
        """
        return self._region

    @region.setter
    def region(self, region: str) -> None:
        """
        Sets the region of this LexV2Bot.
        A region of the Lex V2 bot

        :param region: The region of this LexV2Bot.
        :type: str
        """
        

        self._region = region

    @property
    def description(self) -> str:
        """
        Gets the description of this LexV2Bot.
        A description of the Lex V2 bot

        :return: The description of this LexV2Bot.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description: str) -> None:
        """
        Sets the description of this LexV2Bot.
        A description of the Lex V2 bot

        :param description: The description of this LexV2Bot.
        :type: str
        """
        

        self._description = description

    @property
    def self_uri(self) -> str:
        """
        Gets the self_uri of this LexV2Bot.
        The URI for this object

        :return: The self_uri of this LexV2Bot.
        :rtype: str
        """
        return self._self_uri

    @self_uri.setter
    def self_uri(self, self_uri: str) -> None:
        """
        Sets the self_uri of this LexV2Bot.
        The URI for this object

        :param self_uri: The self_uri of this LexV2Bot.
        :type: str
        """
        

        self._self_uri = self_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

