# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class OperatorPosition(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        OperatorPosition - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'voice_seconds_position': 'int',
            'digital_words_position': 'int'
        }

        self.attribute_map = {
            'voice_seconds_position': 'voiceSecondsPosition',
            'digital_words_position': 'digitalWordsPosition'
        }

        self._voice_seconds_position = None
        self._digital_words_position = None

    @property
    def voice_seconds_position(self) -> int:
        """
        Gets the voice_seconds_position of this OperatorPosition.
        Number of seconds (for voice interactions) from operand match

        :return: The voice_seconds_position of this OperatorPosition.
        :rtype: int
        """
        return self._voice_seconds_position

    @voice_seconds_position.setter
    def voice_seconds_position(self, voice_seconds_position: int) -> None:
        """
        Sets the voice_seconds_position of this OperatorPosition.
        Number of seconds (for voice interactions) from operand match

        :param voice_seconds_position: The voice_seconds_position of this OperatorPosition.
        :type: int
        """
        

        self._voice_seconds_position = voice_seconds_position

    @property
    def digital_words_position(self) -> int:
        """
        Gets the digital_words_position of this OperatorPosition.
        Number of words (for digital interactions) from operand match

        :return: The digital_words_position of this OperatorPosition.
        :rtype: int
        """
        return self._digital_words_position

    @digital_words_position.setter
    def digital_words_position(self, digital_words_position: int) -> None:
        """
        Sets the digital_words_position of this OperatorPosition.
        Number of words (for digital interactions) from operand match

        :param digital_words_position: The digital_words_position of this OperatorPosition.
        :type: int
        """
        

        self._digital_words_position = digital_words_position

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

