# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class WorkPlanBidRanks(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        WorkPlanBidRanks - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'work_plan_bidding_performance': 'int',
            'bidding_tie_breaker': 'str',
            'self_uri': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'work_plan_bidding_performance': 'workPlanBiddingPerformance',
            'bidding_tie_breaker': 'biddingTieBreaker',
            'self_uri': 'selfUri'
        }

        self._id = None
        self._work_plan_bidding_performance = None
        self._bidding_tie_breaker = None
        self._self_uri = None

    @property
    def id(self) -> str:
        """
        Gets the id of this WorkPlanBidRanks.
        The globally unique identifier for the user.

        :return: The id of this WorkPlanBidRanks.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this WorkPlanBidRanks.
        The globally unique identifier for the user.

        :param id: The id of this WorkPlanBidRanks.
        :type: str
        """
        

        self._id = id

    @property
    def work_plan_bidding_performance(self) -> int:
        """
        Gets the work_plan_bidding_performance of this WorkPlanBidRanks.
        Work plan bidding agent performance ranking. The range of values is between 0 and 9999.

        :return: The work_plan_bidding_performance of this WorkPlanBidRanks.
        :rtype: int
        """
        return self._work_plan_bidding_performance

    @work_plan_bidding_performance.setter
    def work_plan_bidding_performance(self, work_plan_bidding_performance: int) -> None:
        """
        Sets the work_plan_bidding_performance of this WorkPlanBidRanks.
        Work plan bidding agent performance ranking. The range of values is between 0 and 9999.

        :param work_plan_bidding_performance: The work_plan_bidding_performance of this WorkPlanBidRanks.
        :type: int
        """
        

        self._work_plan_bidding_performance = work_plan_bidding_performance

    @property
    def bidding_tie_breaker(self) -> str:
        """
        Gets the bidding_tie_breaker of this WorkPlanBidRanks.
        Custom agent ranking metric that some customers can use.

        :return: The bidding_tie_breaker of this WorkPlanBidRanks.
        :rtype: str
        """
        return self._bidding_tie_breaker

    @bidding_tie_breaker.setter
    def bidding_tie_breaker(self, bidding_tie_breaker: str) -> None:
        """
        Sets the bidding_tie_breaker of this WorkPlanBidRanks.
        Custom agent ranking metric that some customers can use.

        :param bidding_tie_breaker: The bidding_tie_breaker of this WorkPlanBidRanks.
        :type: str
        """
        

        self._bidding_tie_breaker = bidding_tie_breaker

    @property
    def self_uri(self) -> str:
        """
        Gets the self_uri of this WorkPlanBidRanks.
        The URI for this object

        :return: The self_uri of this WorkPlanBidRanks.
        :rtype: str
        """
        return self._self_uri

    @self_uri.setter
    def self_uri(self, self_uri: str) -> None:
        """
        Sets the self_uri of this WorkPlanBidRanks.
        The URI for this object

        :param self_uri: The self_uri of this WorkPlanBidRanks.
        :type: str
        """
        

        self._self_uri = self_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

